//
//  NSFontAdditions.m
//  ONSLauncher
//
//  Created by tmkk on 11/04/09.
//  Copyright 2011 tmkk. All rights reserved.
//

#import "NSFontAdditions.h"
#import <ApplicationServices/ApplicationServices.h>

@implementation NSFont (PathUtils)

+ (NSFont *)fontWithPath:(NSString *)path size:(int)size
{
	NSFont *font = nil;
	ATSFontRef atsfRef;
	ATSFontIterator it;
	ATSFontIteratorCreate(kATSFontContextGlobal,NULL,NULL,kATSOptionFlagsUnRestrictedScope,&it);
	while(ATSFontIteratorNext(it,&atsfRef) == noErr) {
		FSRef fsRef;
#if MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5
		ATSFontGetFileReference(atsfRef, &fsRef);
#else
		FSSpec fsSpec;
		ATSFontGetFileSpecification(atsfRef, &fsSpec);
		FSpMakeFSRef(&fsSpec, &fsRef);
#endif
		CFURLRef urlRef = CFURLCreateFromFSRef(NULL, &fsRef);
		if([[(NSURL*)urlRef path] compare:path] == NSOrderedSame) {
			CFStringRef name;
			ATSFontGetName(atsfRef,kATSOptionFlagsDefault,&name);
			font = [NSFont fontWithName:(NSString *)name size:size];
			CFRelease(urlRef);
			CFRelease(name);
			break;
		}
		CFRelease(urlRef);
	}
	ATSFontIteratorRelease(&it);
	return font;
}

- (NSString *)installPath
{
	NSString *path = nil;
	ATSFontRef atsfRef = ATSFontFindFromPostScriptName((CFStringRef)[self fontName],kATSOptionFlagsDefault);
	if(atsfRef) {
		FSRef fsRef;
#if MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_5
		ATSFontGetFileReference(atsfRef, &fsRef);
#else
		FSSpec fsSpec;
		ATSFontGetFileSpecification(atsfRef, &fsSpec);
		FSpMakeFSRef(&fsSpec, &fsRef);
#endif
		CFURLRef urlRef = CFURLCreateFromFSRef(NULL, &fsRef);
		path = [(NSURL*)urlRef path];
		CFRelease(urlRef);
	}
	return path;
}

@end
