//
//  ONSLFontManager.m
//  ONSLauncher
//
//  Created by tmkk on Thu Mar 09 2006.
//  Copyright (c) 2006 tmkk. All rights reserved.
//

#import "ONSLFontManager.h"
#import <AppKit/AppKit.h>

#define NSAppKitVersionNumber10_4 824
#define NSAppKitVersionNumber10_5 949
#define LS(str) NSLocalizedString(str,@"")

@implementation ONSLFontManager

- (id)init
{
	[super init];
	fontArr = [[NSMutableArray alloc] init];
	if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_4 ) {
		[self addNewFont:LS(@"OsakaMono") path:@"/System/Library/Fonts/OsakaMono.dfont"];
		[self addNewFont:LS(@"hiraginogo") path:LS(@"hiraginogopath")];
		[self addNewFont:LS(@"hiraginomin") path:LS(@"hiraginominpath")];
		[self addNewFont:LS(@"hiraginomaru") path:LS(@"hiraginomarupath")];
	}
	else {
		if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_5 ) {
			[self addNewFont:LS(@"OsakaMono") path:LS(@"OsakaMonoPath")];
		}
		else {
			[self addNewFont:LS(@"OsakaMono") path:LS(@"OsakaMonoPath_SL")];
		}
		[self addNewFont:LS(@"hiraginogo") path:LS(@"hiraginogopath_leopard")];
		[self addNewFont:LS(@"hiraginomin") path:LS(@"hiraginominpath_leopard")];
		[self addNewFont:LS(@"hiraginomaru") path:LS(@"hiraginomarupath_leopard")];
	}
	return self;
}

- (void)dealloc
{
	[fontArr release];
	[super dealloc];
}

- (void)addNewFont:(NSString *)name path:(NSString *)path
{
	NSMutableDictionary *dic = [[NSMutableDictionary alloc] init];
	[dic setObject:path forKey:name];
	[fontArr addObject:dic];
	[dic release];
}

- (NSString *)fontNamed:(NSString *)name
{
	int i;
	for(i=0;i<[fontArr count];i++) {
		if([[fontArr objectAtIndex:i] objectForKey:name]) {
			return [[fontArr objectAtIndex:i] objectForKey:name];
		}
	}
	return nil;
}

- (id)saveFontList
{
	return fontArr;
}

- (void)loadFontList:(id)list
{
	int i;
	[fontArr removeAllObjects];
	for(i=0;i<[list count];i++) {
		if([[list objectAtIndex:i] objectForKey:LS(@"OsakaMono")]) {
			if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_4 )
				[self addNewFont:LS(@"OsakaMono") path:@"/System/Library/Fonts/OsakaMono.dfont"];
			else if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_5 )
				[self addNewFont:LS(@"OsakaMono") path:LS(@"OsakaMonoPath")];
			else 
				[self addNewFont:LS(@"OsakaMono") path:LS(@"OsakaMonoPath_SL")];
		}
		else if([[list objectAtIndex:i] objectForKey:LS(@"hiraginogo")]) {
			if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_4 )
				[self addNewFont:LS(@"hiraginogo") path:LS(@"hiraginogopath")];
			else
				[self addNewFont:LS(@"hiraginogo") path:LS(@"hiraginogopath_leopard")];
		}
		else if([[list objectAtIndex:i] objectForKey:LS(@"hiraginomin")]) {
			if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_4 )
				[self addNewFont:LS(@"hiraginomin") path:LS(@"hiraginominpath")];
			else
				[self addNewFont:LS(@"hiraginomin") path:LS(@"hiraginominpath_leopard")];
		}
		else if([[list objectAtIndex:i] objectForKey:LS(@"hiraginomaru")]) {
			if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_4 )
				[self addNewFont:LS(@"hiraginomaru") path:LS(@"hiraginomarupath")];
			else
				[self addNewFont:LS(@"hiraginomaru") path:LS(@"hiraginomarupath_leopard")];
		}
		else [fontArr addObject:[list objectAtIndex:i]];
	}
	//[fontArr addObjectsFromArray:list];
}

@end
